--- /dev/null	1970-01-01 00:00:00.000000000 +0000
+++ mono-2.0.1/mcs/class/System.Web/System.Web.Util/SecureHashCodeProvider.cs	2016-01-21 12:12:12.846852864 +0100
@@ -0,0 +1,131 @@ 
+//
+// System.Collections.SecureHashCodeProvider.cs
+//
+// Authors:
+//   Sergey Chaban (serge@wildwestsoftware.com)
+//   Andreas Nahr (ClassDevelopment@A-SoftTech.com)
+//   Sebastien Pouliot  <sebastien@ximian.com>
+//
+// Copyright (C) 2004-2005 Novell, Inc (http://www.novell.com)
+// Copyright 2012 Xamarin, Inc (http://xamarin.com)
+//
+// Permission is hereby granted, free of charge, to any person obtaining
+// a copy of this software and associated documentation files (the
+// "Software"), to deal in the Software without restriction, including
+// without limitation the rights to use, copy, modify, merge, publish,
+// distribute, sublicense, and/or sell copies of the Software, and to
+// permit persons to whom the Software is furnished to do so, subject to
+// the following conditions:
+// 
+// The above copyright notice and this permission notice shall be
+// included in all copies or substantial portions of the Software.
+// 
+// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
+// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
+// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
+// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+//
+using System;
+using System.Collections;
+using System.Globalization;
+
+namespace System.Web.Util
+{
+	class SecureHashCodeProvider : IHashCodeProvider
+	{
+		static readonly SecureHashCodeProvider singletonInvariant = new SecureHashCodeProvider (CultureInfo.InvariantCulture);
+		static SecureHashCodeProvider singleton;
+		static readonly object sync = new object ();
+		static readonly int seed;
+		
+		TextInfo m_text; // must match MS name for serialization
+
+		public static SecureHashCodeProvider Default {
+			get {
+				lock (sync) {
+					if (singleton == null) {
+						singleton = new SecureHashCodeProvider ();
+					} else if (singleton.m_text == null) {
+						if (!AreEqual (CultureInfo.CurrentCulture, CultureInfo.InvariantCulture))
+							singleton = new SecureHashCodeProvider ();
+					} else if (!AreEqual (singleton.m_text, CultureInfo.CurrentCulture)) {
+						singleton = new SecureHashCodeProvider ();
+					}
+					return singleton;
+				}
+			}
+		}
+		
+		public static SecureHashCodeProvider DefaultInvariant {
+			get { return singletonInvariant; }
+		}
+		
+		static SecureHashCodeProvider ()
+		{
+			// It should be enough to fend off the attack described in
+			// https://bugzilla.novell.com/show_bug.cgi?id=739119
+			// In order to predict value of the seed, the attacker would have to know the exact time when
+			// the server process started and since it's a remote attack, this is next to impossible.
+			// Using milliseconds instead of ticks here would make it easier for the attackers since there
+			// would only be as many as 1000 possible values
+			seed = (int)DateTime.UtcNow.Ticks;
+		}
+		
+		// Public instance constructor
+		public SecureHashCodeProvider ()
+		{
+			CultureInfo culture = CultureInfo.CurrentCulture;
+			if (!AreEqual (culture, CultureInfo.InvariantCulture))
+				m_text = CultureInfo.CurrentCulture.TextInfo;
+		}
+
+		public SecureHashCodeProvider (CultureInfo culture)
+		{
+			if (culture == null)
+ 				throw new ArgumentNullException ("culture");
+			if (!AreEqual (culture, CultureInfo.InvariantCulture))
+				m_text = culture.TextInfo;
+		}
+
+		static bool AreEqual (CultureInfo a, CultureInfo b)
+		{
+			return a.LCID == b.LCID;
+		}
+
+		static bool AreEqual (TextInfo info, CultureInfo culture)
+		{
+			return info.LCID == culture.LCID;
+		}
+		
+		public int GetHashCode (object obj)
+		{
+			if (obj == null)
+				throw new ArgumentNullException ("obj");
+
+			string str = obj as string;
+
+			if (str == null)
+				return obj.GetHashCode ();
+
+			int h = seed;
+			char c;
+
+			if ((m_text != null) && !AreEqual (m_text, CultureInfo.InvariantCulture)) {
+				str = m_text.ToLower (str);
+				for (int i = 0; i < str.Length; i++) {
+					c = str [i];
+					h = h * 31 + c;
+				}
+			} else {
+				for (int i = 0; i < str.Length; i++) {
+					c = Char.ToLower (str [i], CultureInfo.InvariantCulture);
+					h = h * 31 + c;
+				}
+			}
+			return h;
+		}
+	}
+}
--- mono-2.0.1.orig/mcs/class/System.Web/System.Web.dll.sources	2016-01-21 12:11:51.363052265 +0100
+++ mono-2.0.1.orig/mcs/class/System.Web/System.Web.dll.sources	2016-01-21 12:12:12.846852864 +0100
@@ -1158,6 +1158,7 @@ System.Web.Util/ICalls.cs
 System.Web.Util/IWebObjectFactory.cs
 System.Web.Util/IWebPropertyAccessor.cs
 System.Web.Util/MachineKeySectionUtils.cs
+System.Web.Util/SecureHashCodeProvider.cs
 System.Web.Util/SerializationHelper.cs
 System.Web.Util/StrUtils.cs
 System.Web.Util/TimeUtil.cs
--- mono-2.0.1.orig/mcs/class/System.Web/System.Web/WebROCollection.cs	2008-07-01 19:54:08.000000000 +0200
+++ mono-2.0.1.orig/mcs/class/System.Web/System.Web/WebROCollection.cs	2016-01-21 12:39:20.052620769 +0100
@@ -5,6 +5,7 @@ 
 //   	Gonzalo Paniagua Javier (gonzalo@novell.com)
 //
 // (c) 2005 Novell, Inc. (http://www.novell.com)
+// Copyright 2012 Xamarin, Inc (http://xamarin.com)
 //
 //
 // Permission is hereby granted, free of charge, to any person obtaining
@@ -26,8 +27,10 @@ 
 // OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 // WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 //
+using System.Collections;
 using System.Collections.Specialized;
 using System.Text;
+using System.Web.Util;
 
 namespace System.Web
 {
@@ -35,9 +38,9 @@ namespace System.Web
 	{
 		bool got_id;
 		int id;
-#if NET_2_0
-		public WebROCollection () : base (StringComparer.OrdinalIgnoreCase) { }
-#endif
+
+		public WebROCollection () : base (SecureHashCodeProvider.DefaultInvariant, CaseInsensitiveComparer.DefaultInvariant) { }
+
 		public bool GotID {
 			get { return got_id; }
 		}
--- mono-2.0.1.orig/mcs/class/corlib/System.Globalization/TextInfo.cs	2008-09-02 17:45:58.000000000 +0200
+++ mono-2.0.1.orig/mcs/class/corlib/System.Globalization/TextInfo.cs	2016-01-21 12:12:12.847852854 +0100
@@ -136,13 +136,8 @@ namespace System.Globalization {
 			}
 		}
 
-#if NET_2_0
 		[ComVisible (false)]
 		public
-#else
-		// we need it to fully implement System.Collection.CaseInsensitiveHashCodeProvider
-		internal
-#endif
 		int LCID {
 			get { return m_win32LangID; }
 		}
--- mono-2.0.1.orig/mcs/class/System.Web/System.Web.UI/Page.cs	2016-01-21 12:11:51.345052432 +0100
+++ mono-2.0.1.orig/mcs/class/System.Web/System.Web.UI/Page.cs	2016-01-21 12:12:12.848852845 +0100
@@ -1254,7 +1254,7 @@ public partial class Page : TemplateCont
 			_requestValueCollection;
 		
 		if (data != null && data.Count > 0) {
-			Hashtable used = new Hashtable ();
+			Hashtable used = new Hashtable (SecureHashCodeProvider.DefaultInvariant, CaseInsensitiveComparer.DefaultInvariant);
 			foreach (string id in data.AllKeys){
 				if (id == "__VIEWSTATE" || id == postEventSourceID || id == postEventArgumentID ||
 				    id == ClientScriptManager.EventStateFieldName)

